from flask import Flask, render_template, request, send_from_directory, jsonify, make_response,send_file
import os
import time
import requests
import threading
import uuid
app = Flask(__name__)

def png_check(currenttime,files):
    for file in files:
        if file.endswith('.zip'):
            continue
        x = os.popen(f"pngcheck /app/uploads/{currenttime}/{file}.png").read()
        if "OK" not in x:
            return False
    return True

def jpg_check(currenttime,files):
    for file in files:
        if file.endswith('.zip'):
            continue
        marker1 = b'\xff\xd8\xff\xdb'
        marker2 = b'\xff\xd8\xff\xe0\x00\x10\x4a\x46\x49\x46\x00\x01'
        with open(f'/app/uploads/{currenttime}/{file}', 'rb') as f:
            content = f.read()
            if marker1 not in content:
                if marker2 not in content:
                    return False
    return True

@app.route('/', methods=['GET'])
def index():
    return render_template('index.html')

@app.route('/upload', methods=['GET','POST'])
def upload():
    if request.method == 'POST':
        currenttime = str(int(time.time()))
        file = request.files['file']
        os.mkdir(os.path.join(app.root_path, 'uploads', currenttime))
        file.save(os.path.join(app.root_path, 'uploads', currenttime, f'{currenttime}.zip'))
        os.system(f'unzip /app/uploads/{currenttime}/{currenttime}.zip -d /app/uploads/{currenttime}/')
        files = os.listdir(os.path.join(app.root_path, 'uploads', currenttime))
        if len(files) > 2:
            os.system('find /app/uploads/'+currenttime+'/ -type f -delete;')
            return make_response(jsonify({"message": "Please upload only one image"}), 200)
        # for file in files:
        #     print(file)
        #     if "OK" in file:
        #         return make_response(jsonify({"message": "Please name your image to something else"}), 200)
            
        if not png_check(currenttime,files):
            if not jpg_check(currenttime,files):
                os.system('find /app/uploads/'+currenttime+'/ -type f -delete;')
                return make_response(jsonify({"message": "Please upload a valid image"}), 200)

        os.system('find /app/uploads/'+currenttime+'/ -type f -exec mv {} /tmp/ \;')
        return make_response(jsonify({"message": "File uploaded, we will review your image soon and get back to you"}), 200)
    else:
        return render_template('upload.html')

@app.route('/contact', methods=['GET','POST'])
def contact():
    if request.method == 'POST':
        name = request.form.get('name')
        email = request.form.get('email')
        message = request.form.get('message')
        if not name or not email or not message:
            return make_response(jsonify({"message": "Please fill all the fields"}), 200)
        unique_filename = f"{uuid.uuid4()}"
        file_path = os.path.join(app.root_path, 'templates', 'reports', unique_filename)
        with open(file_path, 'w') as file:
            file.write("<html><head><title>Report</title><meta http-equiv=\"Content-Security-Policy\" content=\" script-src 'self' ; object-src 'none' ; \"></head><body>")
            file.write(f"<h1>Name: {name}<br> </h1>")
            file.write(f"<h2>Email: {email}<br> </h2>")
            file.write(f"<p>Message: {message}</p>")
            file.write("</body></html>")
        
        post_url = f"http://localhost:1337/"
        report_url = f"http://localhost:5000/reports/{unique_filename}"
        def post_request(url, data):
            requests.post(url, data=data)
        thread = threading.Thread(target=post_request, args=(post_url, {"url": report_url}))
        thread.start()

        return make_response(jsonify({"message": f"The admin will check your url reports/{unique_filename} shortly"}), 200)
    else:
        return render_template('contact.html')

@app.route('/reports/<path:filename>')
def serve_reports(filename):
    return render_template(f'reports/{filename}')

@app.route('/css/<path:filename>')
def serve_css(filename):
    return send_from_directory(os.path.join(app.root_path, 'assets', 'css'), filename)

@app.route('/uploads/<path:filename>')
def serve_uploads(filename):
    return send_file(os.path.join(app.root_path, 'uploads', filename), mimetype='text/html')

@app.route('/js/<path:filename>')
def serve_js(filename):
    return send_from_directory(os.path.join(app.root_path, 'assets', 'js'), filename)

@app.route('/images/<path:filename>')
def serve_images(filename):
    return send_from_directory(os.path.join(app.root_path, 'assets', 'images'), filename)

@app.route('/fonts/<path:filename>')
def serve_fonts(filename):
    return send_from_directory(os.path.join(app.root_path, 'assets', 'fonts'), filename)



if __name__ == '__main__':
    app.run("0.0.0.0",debug=False)
